package com.yice.webadmin.app.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.github.pagehelper.Page;
import com.yice.common.core.base.dao.BaseDaoMapper;
import com.yice.common.core.base.service.BaseService;
import com.yice.common.core.object.MyRelationParam;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.sequence.wrapper.IdGeneratorWrapper;
import com.yice.webadmin.app.dao.TuningTaskMapper;
import com.yice.webadmin.app.model.TuningRun;
import com.yice.webadmin.app.model.TuningTask;
import com.yice.webadmin.app.service.TuningRunService;
import com.yice.webadmin.app.service.TuningTaskService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 精调任务数据操作服务类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Slf4j
@Service("tuningTaskService")
public class TuningTaskServiceImpl extends BaseService<TuningTask, Long> implements TuningTaskService {

    @Autowired
    private TuningTaskMapper tuningTaskMapper;
    @Autowired
    private TuningRunService tuningRunService;
    @Autowired
    private IdGeneratorWrapper idGenerator;

    /**
     * 返回当前Service的主表Mapper对象。
     *
     * @return 主表Mapper对象。
     */
    @Override
    protected BaseDaoMapper<TuningTask> mapper() {
        return tuningTaskMapper;
    }

    /**
     * 保存新增对象。
     *
     * @param tuningTask 新增对象。
     * @return 返回新增对象。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public TuningTask saveNew(TuningTask tuningTask) {
        tuningTaskMapper.insert(this.buildDefaultValue(tuningTask));
        return tuningTask;
    }

    /**
     * 利用数据库的insertList语法，批量插入对象列表。
     *
     * @param tuningTaskList 新增对象列表。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveNewBatch(List<TuningTask> tuningTaskList) {
        if (CollUtil.isNotEmpty(tuningTaskList)) {
            tuningTaskList.forEach(this::buildDefaultValue);
            tuningTaskMapper.insertList(tuningTaskList);
        }
    }

    /**
     * 更新数据对象。
     *
     * @param tuningTask         更新的对象。
     * @param originalTuningTask 原有数据对象。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean update(TuningTask tuningTask, TuningTask originalTuningTask) {
        MyModelUtil.fillCommonsForUpdate(tuningTask, originalTuningTask);
        // 这里重点提示，在执行主表数据更新之前，如果有哪些字段不支持修改操作，请用原有数据对象字段替换当前数据字段。
        UpdateWrapper<TuningTask> uw = this.createUpdateQueryForNullValue(tuningTask, tuningTask.getTaskId());
        return tuningTaskMapper.update(tuningTask, uw) == 1;
    }

    /**
     * 删除指定数据。
     *
     * @param taskId 主键Id。
     * @return 成功返回true，否则false。
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public boolean remove(Long taskId) {
        if (tuningTaskMapper.deleteById(taskId) == 0) {
            return false;
        }
        tuningRunService.removeByTaskId(taskId);
        return true;
    }

    /**
     * 获取单表查询结果。由于没有关联数据查询，因此在仅仅获取单表数据的场景下，效率更高。
     * 如果需要同时获取关联数据，请移步(getTuningTaskListWithRelation)方法。
     *
     * @param filter  过滤对象。
     * @param orderBy 排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<TuningTask> getTuningTaskList(TuningTask filter, String orderBy) {
        return tuningTaskMapper.getTuningTaskList(filter, orderBy);
    }

    /**
     * 获取主表的查询结果，以及主表关联的字典数据和一对一从表数据，以及一对一从表的字典数据。
     * 该查询会涉及到一对一从表的关联过滤，或一对多从表的嵌套关联过滤，因此性能不如单表过滤。
     * 如果仅仅需要获取主表数据，请移步(getTuningTaskList)，以便获取更好的查询性能。
     *
     * @param filter          主表过滤对象。
     * @param tuningRunFilter 一对多从表过滤对象。
     * @param orderBy         排序参数。
     * @return 查询结果集。
     */
    @Override
    public List<TuningTask> getTuningTaskListWithRelation(TuningTask filter, TuningRun tuningRunFilter, String orderBy) {
        List<TuningTask> resultList =
                tuningTaskMapper.getTuningTaskListEx(filter, tuningRunFilter, orderBy);
        // 在缺省生成的代码中，如果查询结果resultList不是Page对象，说明没有分页，那么就很可能是数据导出接口调用了当前方法。
        // 为了避免一次性的大量数据关联，规避因此而造成的系统运行性能冲击，这里手动进行了分批次读取，开发者可按需修改该值。
        int batchSize = resultList instanceof Page ? 0 : 1000;
        this.buildRelationForDataList(resultList, MyRelationParam.normal(), batchSize);
        return resultList;
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public TuningTask saveAndCreateVersion(TuningTask tuningTask, TuningRun tuningRun) {
        TuningTask reTuningTask = this.saveNew(tuningTask);
        tuningRun.setTaskId(reTuningTask.getTaskId());
        this.tuningRunService.saveNew(tuningRun);
        return reTuningTask;
    }

    private TuningTask buildDefaultValue(TuningTask tuningTask) {
        if (tuningTask.getTaskId() == null) {
            tuningTask.setTaskId(idGenerator.nextLongId());
        }
        MyModelUtil.fillCommonsForInsert(tuningTask);
        return tuningTask;
    }
}
